/*
*	This file is part of the EMFexplorer projet.
*	Copyright (C) 2004 Smith Charles.
*
*	This library is free software; you can redistribute it and/or
*	modify it under the terms of the GNU Lesser General Public
*	License as published by the Free Software Foundation; either
*	version 2.1 of the License, or (at your option) any later version.
*
*   This library is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
*   Lesser General Public License for more details.
*
*   You should have received a copy of the GNU Lesser General Public
*   License along with this library; if not, write to the Free Software
*   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
*
*	Extension: for commercial use, apply the Equity Public License, which
*	adds to the normal terms of the GLPL a condition of donation to the author.
*   If you are interested in support for this source code,
*   contact Smith Charles <smith.charles@free.fr> for more information.
*/

#include "stdafx.h"
#include "emfexplorer.h"
#include "SCEMFXBasePropPage.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSCEMFXBasePropPage property page

IMPLEMENT_DYNCREATE(CSCEMFXBasePropPage, CPropertyPage)

CSCEMFXBasePropPage::CSCEMFXBasePropPage():
	CPropertyPage(),
	m_pIExchanger(NULL),
	m_iFolderID(-1),
	m_bSCModified(FALSE)
{
	ASSERT(0); // don't want you to call it
}

CSCEMFXBasePropPage::CSCEMFXBasePropPage(UINT nIDTemplate, UINT nIDCaption,
										 I_SCPropExchange* pPx/*=NULL*/):
	CPropertyPage(nIDTemplate, nIDCaption),
	m_pIExchanger(pPx),
	m_iFolderID(-1)
{
	//{{AFX_DATA_INIT(CSCEMFXBasePropPage)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CSCEMFXBasePropPage::~CSCEMFXBasePropPage()
{
}

void CSCEMFXBasePropPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSCEMFXBasePropPage)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

SC_IMPLEMENT_ENABLE_CONTROL(CSCEMFXBasePropPage)

BEGIN_MESSAGE_MAP(CSCEMFXBasePropPage, CPropertyPage)
	//{{AFX_MSG_MAP(CSCEMFXBasePropPage)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CSCEMFXBasePropPage message handlers

BOOL CSCEMFXBasePropPage::OnSetActive() 
{
	BOOL bOk = CPropertyPage::OnSetActive();

	CWnd* pParent = GetParent();
	ASSERT(pParent);
	NMHDR nmhdr;
	nmhdr.code = PSN_SETACTIVE;
	nmhdr.hwndFrom = m_hWnd;
	nmhdr.idFrom = GetDlgCtrlID();
	pParent->SendMessage(WM_NOTIFY, (WPARAM)nmhdr.idFrom, (LPARAM)&nmhdr);
	return bOk;
}
