/*
*	This file is part of the EMFexplorer projet.
*	Copyright (C) 2004 Smith Charles.
*
*	This library is free software; you can redistribute it and/or
*	modify it under the terms of the GNU Lesser General Public
*	License as published by the Free Software Foundation; either
*	version 2.1 of the License, or (at your option) any later version.
*
*   This library is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
*   Lesser General Public License for more details.
*
*   You should have received a copy of the GNU Lesser General Public
*   License along with this library; if not, write to the Free Software
*   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
*
*	Extension: for commercial use, apply the Equity Public License, which
*	adds to the normal terms of the GLPL a condition of donation to the author.
*   If you are interested in support for this source code,
*   contact Smith Charles <smith.charles@free.fr> for more information.
*/
#if !defined(AFX_SCEMFXDLGSETTINGS_H__56EE7B9C_C01B_41A1_BD88_700048EFCBBF__INCLUDED_)
#define AFX_SCEMFXDLGSETTINGS_H__56EE7B9C_C01B_41A1_BD88_700048EFCBBF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// SCEMFXDlgSettings.h : header file
//

#include "SCEMFXColorsPropPage.h"
#include "SCEMFXGDIpPropPage.h"
#include "SCEMFXGenPropPage.h"

/////////////////////////////////////////////////////////////////////////////
// CSCEMFXDlgSettings dialog

// WARNING: a property sheet would contain this property page containing
// a property sheet containing three property pages. Well convoluted! Isn't it?
//

class CSCEMFXDlgSettings : public CPropertyPage
{
	DECLARE_DYNCREATE(CSCEMFXDlgSettings)

// Construction
public:
	CSCEMFXDlgSettings();
	CSCEMFXDlgSettings(UINT nIDCaption, I_SCPropExchange* pPx, int iFolderID);
	~CSCEMFXDlgSettings();

// Dialog Data
	//{{AFX_DATA(CSCEMFXDlgSettings)
	enum { IDD = IDD_PROPPAGE_SETTINGS };
		// NOTE - ClassWizard will add data members here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_DATA
	
	void SCClose()
	{
		if (IsWindow(m_PropertySheet.m_hWnd))
			m_PropertySheet.DestroyWindow();
	}
	BOOL SCGetModified()
	{
		if (m_dlgGenPage.SCGetModified())
			return TRUE;
		if (m_dlgGDIpPage.SCGetModified())
			return TRUE;
		if (m_dlgColorsPage.SCGetModified())
			return TRUE;
		return FALSE;
	}

// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CSCEMFXDlgSettings)
	public:
	virtual void OnOK();
	virtual BOOL OnSetActive();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CSCEMFXDlgSettings)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	CSCEMFXGenPropPage		m_dlgGenPage;
	CSCEMFXGDIpPropPage		m_dlgGDIpPage;
	CSCEMFXColorsPropPage	m_dlgColorsPage;
	CPropertySheet			m_PropertySheet;
	int						m_iFolderID;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SCEMFXDLGSETTINGS_H__56EE7B9C_C01B_41A1_BD88_700048EFCBBF__INCLUDED_)
