/*
*	This file is part of the EMFexplorer projet.
*	Copyright (C) 2004 Smith Charles.
*
*	This library is free software; you can redistribute it and/or
*	modify it under the terms of the GNU Lesser General Public
*	License as published by the Free Software Foundation; either
*	version 2.1 of the License, or (at your option) any later version.
*
*   This library is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
*   Lesser General Public License for more details.
*
*   You should have received a copy of the GNU Lesser General Public
*   License along with this library; if not, write to the Free Software
*   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
*
*	Extension: for commercial use, apply the Equity Public License, which
*	adds to the normal terms of the GLPL a condition of donation to the author.
*   If you are interested in support for this source code,
*   contact Smith Charles <smith.charles@free.fr> for more information.
*/
#if !defined(AFX_SCEMFAXCOLORSPROPPAGE_H__5A34E1EB_517A_4881_9C9F_6E30C443B85B__INCLUDED_)
#define AFX_SCEMFAXCOLORSPROPPAGE_H__5A34E1EB_517A_4881_9C9F_6E30C443B85B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// SCEMFAxColorsPropPage.h : header file
//
#include "SCGenInclude.h"
#include SC_INC_WINLIB(SCOleBaseOlePPg.h)

#include "SCGenInclude.h"
#include SC_INC_WINLIB(SCColorBox.h)
#include SC_INC_WINLIB(SCWinGUI.h)

/////////////////////////////////////////////////////////////////////////////
// CSCEMFAxColorsPropPage : Property page dialog

class CSCEMFAxColorsPropPage : public CSCBaseOlePropertyPage
{
	DECLARE_DYNCREATE(CSCEMFAxColorsPropPage)
	DECLARE_OLECREATE_EX(CSCEMFAxColorsPropPage)

// Constructors
public:
	CSCEMFAxColorsPropPage();

// Dialog Data
	//{{AFX_DATA(CSCEMFAxColorsPropPage)
	enum { IDD = IDD_PROPPAGE_COLORS };
	CSCColorBox	m_CmbPaperColorRGB;
	CSCSysColorBox	m_CmbPaperColorSys;
	int		m_nTransparencyMode;
	int		m_nReverseVideoMode;
	int		m_nPaperColorStyle;
	//}}AFX_DATA

// Implementation
protected:
	virtual void DoDataExchange(CDataExchange* pDX);        // DDX/DDV support

	SC_DECLARE_ENABLE_CONTROL()
	void SCEnableControls();

// Message maps
protected:
	//{{AFX_MSG(CSCEMFAxColorsPropPage)
	virtual BOOL OnInitDialog();
	afx_msg void OnRadioPapercolorTrans();
	afx_msg void OnRadioPapercolorSys();
	afx_msg void OnRadioPapercolorRgb();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	OLE_COLOR m_nPaperColor;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SCEMFAXCOLORSPROPPAGE_H__5A34E1EB_517A_4881_9C9F_6E30C443B85B__INCLUDED_)
