/*
*	This file is part of the EMFexplorer projet.
*	Copyright (C) 2004 Smith Charles.
*
*	This library is free software; you can redistribute it and/or
*	modify it under the terms of the GNU Lesser General Public
*	License as published by the Free Software Foundation; either
*	version 2.1 of the License, or (at your option) any later version.
*
*   This library is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
*   Lesser General Public License for more details.
*
*   You should have received a copy of the GNU Lesser General Public
*   License along with this library; if not, write to the Free Software
*   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
*
*	Extension: for commercial use, apply the Equity Public License, which
*	adds to the normal terms of the GLPL a condition of donation to the author.
*   If you are interested in support for this source code,
*   contact Smith Charles <smith.charles@free.fr> for more information.
*/

#include "stdafx.h"
#include "scemfax.h"
#include "SCEMFAxPropSheet.h"
#include <afxconv.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSCEMFAxPropSheet

IMPLEMENT_DYNAMIC(CSCEMFAxPropSheet, CPropertySheet)

CSCEMFAxPropSheet::CSCEMFAxPropSheet(UINT nIDCaption, CWnd* pParentWnd, UINT iSelectPage)
	:CPropertySheet(nIDCaption, pParentWnd, iSelectPage)
{
	//SCInitMembers();
	//SCAddControlPages();
}

CSCEMFAxPropSheet::CSCEMFAxPropSheet(LPCTSTR pszCaption, CWnd* pParentWnd, UINT iSelectPage)
	:CPropertySheet(pszCaption, pParentWnd, iSelectPage)
{
	//SCInitMembers();
	//SCAddControlPages();
}

CSCEMFAxPropSheet::~CSCEMFAxPropSheet()
{
}


BEGIN_MESSAGE_MAP(CSCEMFAxPropSheet, CPropertySheet)
	//{{AFX_MSG_MAP(CSCEMFAxPropSheet)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSCEMFAxPropSheet message handlers

void CSCEMFAxPropSheet::SCAddControlPages()
{
}

void CSCEMFAxPropSheet::SCInitMembers()
{
	// Remove the apply button
}


BOOL CSCEMFAxPropSheet::OnInitDialog() 
{
	BOOL bResult = CPropertySheet::OnInitDialog();
	
	//	specialized code here	
	return bResult;
}

/////////////////////////////////////////////////////////////////////////////
// Usable part
UINT CSCEMFAxPropSheet::SCDoModal(int x, int y, LPDISPATCH pIDispatch, CAUUID* pCAUUIDs, LCID lcid)
{
	USES_CONVERSION;

	OCPFIPARAMS ocparams;
	ocparams.cbStructSize = sizeof(ocparams);
	ocparams.hWndOwner = m_psh.hwndParent;
	ocparams.x = x;
	ocparams.y = y;
	ocparams.lpszCaption = T2COLE(m_psh.pszCaption);

	ocparams.cObjects = 1;
	ocparams.lplpUnk = (IUnknown**)&pIDispatch;
	ocparams.cPages = pCAUUIDs->cElems;
	ocparams.lpPages = pCAUUIDs->pElems;

	ocparams.lcid = lcid;
	ocparams.dispidInitialProperty = DISPID_UNKNOWN;

	OleCreatePropertyFrameIndirect(&ocparams);
	return 0;
}
/////////////////////////////////////////////////////////////////////////////


