/*
*	This file is part of the EMFexplorer projet.
*	Copyright (C) 2004 Smith Charles.
*
*	This library is free software; you can redistribute it and/or
*	modify it under the terms of the GNU Lesser General Public
*	License as published by the Free Software Foundation; either
*	version 2.1 of the License, or (at your option) any later version.
*
*   This library is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
*   Lesser General Public License for more details.
*
*   You should have received a copy of the GNU Lesser General Public
*   License along with this library; if not, write to the Free Software
*   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
*
*	Extension: for commercial use, apply the Equity Public License, which
*	adds to the normal terms of the GLPL a condition of donation to the author.
*   If you are interested in support for this source code,
*   contact Smith Charles <smith.charles@free.fr> for more information.
*/
#ifndef _WERR_H_
#define _WERR_H_

void SCShowWinError();
void SCShowWinError(DWORD dwError, LPCTSTR lpszCaption=NULL, LPCTSTR lpszFnMsg=NULL);

#ifdef _DEBUG
	#define SC_LOGERROR(strMsg) \
	{ \
		AfxMessageBox(strMsg); \
	}
	#define SC_LOGERROR1(szFmt, Param) \
	{ \
		CString strMsg; \
		strMsg.Format(szFmt, Param); \
		AfxMessageBox(strMsg); \
	}
	#define SC_LOGERROR2(szFmt, Param1, Param2) \
	{ \
		CString strMsg; \
		strMsg.Format(szFmt, Param1, Param2); \
		AfxMessageBox(strMsg); \
	}
#else
	#define SC_LOGERROR(strMsg)
	#define SC_LOGERROR1(szFmt, Param)
	#define SC_LOGERROR2(szFmt, Param1, Param2)
#endif


#endif //_WERR_H_
//  ------------------------------------------------------------
