/*
*	This file is part of the EMFexplorer projet.
*	Copyright (C) 2004 Smith Charles.
*
*	This library is free software; you can redistribute it and/or
*	modify it under the terms of the GNU Lesser General Public
*	License as published by the Free Software Foundation; either
*	version 2.1 of the License, or (at your option) any later version.
*
*   This library is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
*   Lesser General Public License for more details.
*
*   You should have received a copy of the GNU Lesser General Public
*   License along with this library; if not, write to the Free Software
*   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
*
*	Extension: for commercial use, apply the Equity Public License, which
*	adds to the normal terms of the GLPL a condition of donation to the author.
*   If you are interested in support for this source code,
*   contact Smith Charles <smith.charles@free.fr> for more information.
*/
#ifndef _SCGENTYPES_H_
#define _SCGENTYPES_H_


#ifdef _WIN32
// Match WIN32 platform
#define SCgenBOOL			BOOL
#define SCgenBYTE			BYTE
#define SCgenTCHAR			TCHAR
#define SCgenWORD			WORD
#define SCgenSHORT			SHORT
#define SCgenLONG			LONG
#define SCgenINT			INT
#define SCgenFLOAT			FLOAT
#define SCgenDOUBLE			double

#define SCgenSIZE_T			size_t

#define SCgenUCHAR			UCHAR
#define SCgenUWORD			UWORD
#define SCgenUSHORT			USHORT
#define SCgenULONG			ULONG
#define SCgenUINT			UINT

#define SCgenTRUE			TRUE
#define SCgenFALSE			FALSE

#else
// Default to standard C++
typedef	bool				SCgenBOOL;
typedef	unsigned char		SCgenBYTE;

#ifdef _UNICODE
	typedef	wchar_t			SCgenTCHAR;
#else
	typedef	char			SCgenTCHAR;
#endif

typedef	short				SCgenWORD;
typedef	long int			SCgenLONG;
typedef long int			SCgenINT;
typedef	float				SCgenFLOAT;
typedef	double				SCgenDOUBLE;

typedef	size_t              SCgenSIZE_T;

typedef	unsigned char		SCgenUCHAR;
typedef	unsigned short		SCgenUWORD;
typedef	unsigned short		SCgenUSHORT;
typedef	unsigned long int	SCgenULONG;
typedef	unsigned long int	SCgenUINT;

#define SCgenTRUE			true
#define SCgenFALSE			false

#endif

#endif //_SCGENTYPES_H_
//  ------------------------------------------------------------
