/*
*	This file is part of the EMFexplorer projet.
*	Copyright (C) 2004 Smith Charles.
*
*	This library is free software; you can redistribute it and/or
*	modify it under the terms of the GNU Lesser General Public
*	License as published by the Free Software Foundation; either
*	version 2.1 of the License, or (at your option) any later version.
*
*   This library is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
*   Lesser General Public License for more details.
*
*   You should have received a copy of the GNU Lesser General Public
*   License along with this library; if not, write to the Free Software
*   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
*
*	Extension: for commercial use, apply the Equity Public License, which
*	adds to the normal terms of the GLPL a condition of donation to the author.
*   If you are interested in support for this source code,
*   contact Smith Charles <smith.charles@free.fr> for more information.
*/
#ifndef _SCGENINCLUDE_H_
#define _SCGENINCLUDE_H_

// Note: this stuff relies on Visual C++ IDE
// 1. This file must be placed in a directory declared in the VC options tab
// 2. All paths are computed relatively to the main workspace directory
//    (the one containing the main .dsw file)
//	  For example, if AMakeAllEMFx.dsw is in d:\devl\emfx\src, this directory must be
//	  . Set as a global include directory in the IDE
//	  . (for command line builds) Set with the /I compiler directive
//		 or in INCLUDE environment variable
// 3. Usage:
//		a) include this file	ex.=> #include "SCGenInclude.h"
//		b) call a macro			ex.=> #include SC_INC_EMFLIB(SCEMFDefs.h)
//		this gives access to SCEMFDefs.h from anywhere in the workspace
// 4. When project architecture changes, you have one line to modify in this file.
// 5. The bad news is that "Open document" in VC's contextual menu won't work,
//	  as VC won't solve the macro on the fly.

//-- General purpose macros ----
#define STRX(x)	#x

//--- Macros for includes ------------------------------
#define SC_INC_COMMON(incfile)	STRX(Common/Include/ ##incfile)
#define SC_INC_GENLIB(incfile)	STRX(Common/SCGenLib/ ##incfile)
#define SC_INC_ERRLIB(incfile)	STRX(Common/ErrorLib/ ##incfile)
#define SC_INC_ZIPLIB(incfile)	STRX(Common/zlib/zlib-1.2.1/ ##incfile)
#define SC_INC_WINLIB(incfile)	STRX(Client/SCWinLib/ ##incfile)
#define SC_INC_EMFLIB(incfile)	STRX(Client/SCEMFLib/ ##incfile)
#define SC_INC_SHARED(incfile)	STRX(Client/SCSharedLib/ ##incfile)

#define SC_INC_EMFEXP(incfile)	STRX(Client/EMFexplorer/ ##incfile)
#define SC_INC_EMFAX(incfile)	STRX(Client/SCEMFAx/ ##incfile)




#endif //_SCGENINCLUDE_H_
//  ------------------------------------------------------------
